Index: branches/SHM-3.0-dev/cfg/encoder_lowdelay_P_main.cfg
===================================================================
--- branches/SHM-3.0-dev/cfg/encoder_lowdelay_P_main.cfg	(revision 356)
+++ branches/SHM-3.0-dev/cfg/encoder_lowdelay_P_main.cfg	(revision 357)
@@ -22,9 +22,9 @@
 DecodingRefreshType           : 0           # Random Accesss 0:none, 1:CDR, 2:IDR
 GOPSize                       : 4           # GOP Size (number of B slice = GOPSize-1)
-#        Type POC QPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2  temporal_id #ref_pics_active #ref_pics reference pictures predict deltaRPS #ref_idcs reference idcs 
-Frame1:  P    1   3        0.4624   0            0               0           4                4         -1 -5 -9 -13       0
-Frame2:  P    2   2        0.4624   0            0               0           4                4         -1 -2 -6 -10       1      -1       5         1 1 1 0 1
-Frame3:  P    3   3        0.4624   0            0               0           4                4         -1 -3 -7 -11       1      -1       5         0 1 1 1 1            
-Frame4:  P    4   1        0.578    0            0               0           4                4         -1 -4 -8 -12       1      -1       5         0 1 1 1 1
+#        Type POC QPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2  temporal_id #ref_pics_active #ref_pics reference pictures predict deltaRPS #ref_idcs reference idcs #UseExtUsedByCurr  ExtUsedByCurr(for each ref pic)
+Frame1:  P    1   3        0.4624   0            0               0           4                4         -1 -5 -9 -13       0                                           0
+Frame2:  P    2   2        0.4624   0            0               0           4                4         -1 -2 -6 -10       1      -1       5         1 1 1 0 1         0
+Frame3:  P    3   3        0.4624   0            0               0           4                4         -1 -3 -7 -11       1      -1       5         0 1 1 1 1         0
+Frame4:  P    4   1        0.578    0            0               0           4                4         -1 -4 -8 -12       1      -1       5         0 1 1 1 1         0
 
 #=========== Motion Search =============
Index: branches/SHM-3.0-dev/cfg/encoder_lowdelay_P_main10.cfg
===================================================================
--- branches/SHM-3.0-dev/cfg/encoder_lowdelay_P_main10.cfg	(revision 356)
+++ branches/SHM-3.0-dev/cfg/encoder_lowdelay_P_main10.cfg	(revision 357)
@@ -22,9 +22,9 @@
 DecodingRefreshType           : 0           # Random Accesss 0:none, 1:CDR, 2:IDR
 GOPSize                       : 4           # GOP Size (number of B slice = GOPSize-1)
-#        Type POC QPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2  temporal_id #ref_pics_active #ref_pics reference pictures predict deltaRPS #ref_idcs reference idcs 
-Frame1:  P    1   3        0.4624   0            0               0           4                4         -1 -5 -9 -13       0
-Frame2:  P    2   2        0.4624   0            0               0           4                4         -1 -2 -6 -10       1      -1       5         1 1 1 0 1
-Frame3:  P    3   3        0.4624   0            0               0           4                4         -1 -3 -7 -11       1      -1       5         0 1 1 1 1            
-Frame4:  P    4   1        0.578    0            0               0           4                4         -1 -4 -8 -12       1      -1       5         0 1 1 1 1
+#        Type POC QPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2  temporal_id #ref_pics_active #ref_pics reference pictures predict deltaRPS #ref_idcs reference idcs #UseExtUsedByCurr  ExtUsedByCurr(for each ref pic)
+Frame1:  P    1   3        0.4624   0            0               0           4                4         -1 -5 -9 -13       0                                           0
+Frame2:  P    2   2        0.4624   0            0               0           4                4         -1 -2 -6 -10       1      -1       5         1 1 1 0 1         0
+Frame3:  P    3   3        0.4624   0            0               0           4                4         -1 -3 -7 -11       1      -1       5         0 1 1 1 1         0
+Frame4:  P    4   1        0.578    0            0               0           4                4         -1 -4 -8 -12       1      -1       5         0 1 1 1 1         0
 
 #=========== Motion Search =============
Index: branches/SHM-3.0-dev/cfg/encoder_lowdelay_main.cfg
===================================================================
--- branches/SHM-3.0-dev/cfg/encoder_lowdelay_main.cfg	(revision 356)
+++ branches/SHM-3.0-dev/cfg/encoder_lowdelay_main.cfg	(revision 357)
@@ -22,9 +22,9 @@
 DecodingRefreshType           : 0           # Random Accesss 0:none, 1:CDR, 2:IDR
 GOPSize                       : 4           # GOP Size (number of B slice = GOPSize-1)
-#        Type POC QPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2  temporal_id #ref_pics_active #ref_pics reference pictures predict deltaRPS #ref_idcs reference idcs 
-Frame1:  B    1   3        0.4624   0            0               0           4                4         -1 -5 -9 -13       0
-Frame2:  B    2   2        0.4624   0            0               0           4                4         -1 -2 -6 -10       1      -1       5         1 1 1 0 1
-Frame3:  B    3   3        0.4624   0            0               0           4                4         -1 -3 -7 -11       1      -1       5         0 1 1 1 1            
-Frame4:  B    4   1        0.578    0            0               0           4                4         -1 -4 -8 -12       1      -1       5         0 1 1 1 1
+#        Type POC QPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2  temporal_id #ref_pics_active #ref_pics reference pictures predict deltaRPS #ref_idcs reference idcs #UseExtUsedByCurr  ExtUsedByCurr(for each ref pic)
+Frame1:  B    1   3        0.4624   0            0               0           4                4         -1 -5 -9 -13       0                                           0
+Frame2:  B    2   2        0.4624   0            0               0           4                4         -1 -2 -6 -10       1      -1       5         1 1 1 0 1         0
+Frame3:  B    3   3        0.4624   0            0               0           4                4         -1 -3 -7 -11       1      -1       5         0 1 1 1 1         0
+Frame4:  B    4   1        0.578    0            0               0           4                4         -1 -4 -8 -12       1      -1       5         0 1 1 1 1         0
 
 #=========== Motion Search =============
Index: branches/SHM-3.0-dev/cfg/encoder_lowdelay_main10.cfg
===================================================================
--- branches/SHM-3.0-dev/cfg/encoder_lowdelay_main10.cfg	(revision 356)
+++ branches/SHM-3.0-dev/cfg/encoder_lowdelay_main10.cfg	(revision 357)
@@ -22,9 +22,9 @@
 DecodingRefreshType           : 0           # Random Accesss 0:none, 1:CDR, 2:IDR
 GOPSize                       : 4           # GOP Size (number of B slice = GOPSize-1)
-#        Type POC QPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2  temporal_id #ref_pics_active #ref_pics reference pictures predict deltaRPS #ref_idcs reference idcs 
-Frame1:  B    1   3        0.4624   0            0               0           4                4         -1 -5 -9 -13       0
-Frame2:  B    2   2        0.4624   0            0               0           4                4         -1 -2 -6 -10       1      -1       5         1 1 1 0 1
-Frame3:  B    3   3        0.4624   0            0               0           4                4         -1 -3 -7 -11       1      -1       5         0 1 1 1 1            
-Frame4:  B    4   1        0.578    0            0               0           4                4         -1 -4 -8 -12       1      -1       5         0 1 1 1 1
+#        Type POC QPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2  temporal_id #ref_pics_active #ref_pics reference pictures predict deltaRPS #ref_idcs reference idcs #UseExtUsedByCurr  ExtUsedByCurr(for each ref pic)
+Frame1:  B    1   3        0.4624   0            0               0           4                4         -1 -5 -9 -13       0                                           0
+Frame2:  B    2   2        0.4624   0            0               0           4                4         -1 -2 -6 -10       1      -1       5         1 1 1 0 1         0
+Frame3:  B    3   3        0.4624   0            0               0           4                4         -1 -3 -7 -11       1      -1       5         0 1 1 1 1         0
+Frame4:  B    4   1        0.578    0            0               0           4                4         -1 -4 -8 -12       1      -1       5         0 1 1 1 1         0
 
 #=========== Motion Search =============
Index: branches/SHM-3.0-dev/cfg/encoder_randomaccess_main.cfg
===================================================================
--- branches/SHM-3.0-dev/cfg/encoder_randomaccess_main.cfg	(revision 356)
+++ branches/SHM-3.0-dev/cfg/encoder_randomaccess_main.cfg	(revision 357)
@@ -22,22 +22,22 @@
 DecodingRefreshType           : 1           # Random Accesss 0:none, 1:CDR, 2:IDR
 GOPSize                       : 8           # GOP Size (number of B slice = GOPSize-1)
-#        Type POC QPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2 temporal_id #ref_pics_active #ref_pics reference pictures     predict deltaRPS #ref_idcs reference idcs 
-Frame1:  B    8   1        0.442    0            0              0           4                4         -8 -10 -12 -16         0
-Frame2:  B    4   2        0.3536   0            0              0           2                3         -4 -6  4               1       4        5         1 1 0 0 1
-Frame3:  B    2   3        0.3536   0            0              0           2                4         -2 -4  2 6             1       2        4         1 1 1 1  
-Frame4:  B    1   4        0.68     0            0              0           2                4         -1  1  3 7             1       1        5         1 0 1 1 1 
-Frame5:  B    3   4        0.68     0            0              0           2                4         -1 -3  1 5             1      -2        5         1 1 1 1 0
-Frame6:  B    6   3        0.3536   0            0              0           2                4         -2 -4 -6 2             1      -3        5         1 1 1 1 0
-Frame7:  B    5   4        0.68     0            0              0           2                4         -1 -5  1 3             1       1        5         1 0 1 1 1  
-Frame8:  B    7   4        0.68     0            0              0           2                4         -1 -3 -7 1             1      -2        5         1 1 1 1 0
+#        Type POC QPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2 temporal_id #ref_pics_active #ref_pics reference pictures     predict deltaRPS #ref_idcs reference idcs #UseExtUsedByCurr  ExtUsedByCurr(for each ref pic)
+Frame1:  B    8   1        0.442    0            0              0           4                4         -8 -10 -12 -16         0                                            0
+Frame2:  B    4   2        0.3536   0            0              0           2                3         -4 -6  4               1       4        5         1 1 0 0 1         0
+Frame3:  B    2   3        0.3536   0            0              0           2                4         -2 -4  2 6             1       2        4         1 1 1 1           0
+Frame4:  B    1   4        0.68     0            0              0           2                4         -1  1  3 7             1       1        5         1 0 1 1 1         0
+Frame5:  B    3   4        0.68     0            0              0           2                4         -1 -3  1 5             1      -2        5         1 1 1 1 0         0
+Frame6:  B    6   3        0.3536   0            0              0           2                4         -2 -4 -6 2             1      -3        5         1 1 1 1 0         0
+Frame7:  B    5   4        0.68     0            0              0           2                4         -1 -5  1 3             1       1        5         1 0 1 1 1         0
+Frame8:  B    7   4        0.68     0            0              0           2                4         -1 -3 -7 1             1      -2        5         1 1 1 1 0         0
 
-FrameEL1:  B    8   1        0.442    0            0              0           4                4         -8 -10 -12 -16         0
-FrameEL2:  B    4   2        0.3536   0            0              0           2                3         -4 -6  4               1       4        5         1 1 0 0 1
-FrameEL3:  B    2   3        0.3536   0            0              0           2                4         -2 -4  2 6             1       2        4         1 1 1 1
-FrameEL4:  B    1   4        0.68     0            0              0           2                4         -1  1  3 7             1       1        5         1 0 1 1 1
-FrameEL5:  B    3   4        0.68     0            0              0           2                4         -1 -3  1 5             1      -2        5         1 1 1 1 0
-FrameEL6:  B    6   3        0.3536   0            0              0           2                4         -2 -4 -6 2             0
-FrameEL7:  B    5   4        0.68     0            0              0           2                4         -1 -5  1 3             0
-FrameEL8:  B    7   4        0.68     0            0              0           2                4         -1 -3 -7 1             0
+FrameEL1:  B    8   1        0.442    0            0              0           4                4         -8 -10 -12 -16         0                                          0
+FrameEL2:  B    4   2        0.3536   0            0              0           2                3         -4 -6  4               1       4        5         1 1 0 0 1       0
+FrameEL3:  B    2   3        0.3536   0            0              0           2                4         -2 -4  2 6             1       2        4         1 1 1 1         0
+FrameEL4:  B    1   4        0.68     0            0              0           2                4         -1  1  3 7             1       1        5         1 0 1 1 1       0
+FrameEL5:  B    3   4        0.68     0            0              0           2                4         -1 -3  1 5             1      -2        5         1 1 1 1 0       0
+FrameEL6:  B    6   3        0.3536   0            0              0           2                4         -2 -4 -6 2             0                                          1    1 1 0 1
+FrameEL7:  B    5   4        0.68     0            0              0           2                4         -1 -5  1 3             0                                          0
+FrameEL8:  B    7   4        0.68     0            0              0           2                4         -1 -3 -7 1             0                                          1    1 1 0 1
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
Index: branches/SHM-3.0-dev/cfg/encoder_randomaccess_main10.cfg
===================================================================
--- branches/SHM-3.0-dev/cfg/encoder_randomaccess_main10.cfg	(revision 356)
+++ branches/SHM-3.0-dev/cfg/encoder_randomaccess_main10.cfg	(revision 357)
@@ -22,22 +22,22 @@
 DecodingRefreshType           : 1           # Random Accesss 0:none, 1:CDR, 2:IDR
 GOPSize                       : 8           # GOP Size (number of B slice = GOPSize-1)
-#        Type POC QPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2 temporal_id #ref_pics_active #ref_pics reference pictures     predict deltaRPS #ref_idcs reference idcs 
-Frame1:  B    8   1        0.442    0            0              0           4                4         -8 -10 -12 -16         0
-Frame2:  B    4   2        0.3536   0            0              0           2                3         -4 -6  4               1       4        5         1 1 0 0 1
-Frame3:  B    2   3        0.3536   0            0              0           2                4         -2 -4  2 6             1       2        4         1 1 1 1  
-Frame4:  B    1   4        0.68     0            0              0           2                4         -1  1  3 7             1       1        5         1 0 1 1 1 
-Frame5:  B    3   4        0.68     0            0              0           2                4         -1 -3  1 5             1      -2        5         1 1 1 1 0
-Frame6:  B    6   3        0.3536   0            0              0           2                4         -2 -4 -6 2             1      -3        5         1 1 1 1 0
-Frame7:  B    5   4        0.68     0            0              0           2                4         -1 -5  1 3             1       1        5         1 0 1 1 1  
-Frame8:  B    7   4        0.68     0            0              0           2                4         -1 -3 -7 1             1      -2        5         1 1 1 1 0
+#        Type POC QPoffset QPfactor tcOffsetDiv2 betaOffsetDiv2 temporal_id #ref_pics_active #ref_pics reference pictures     predict deltaRPS #ref_idcs reference idcs #UseExtUsedByCurr  ExtUsedByCurr(for each ref pic)
+Frame1:  B    8   1        0.442    0            0              0           4                4         -8 -10 -12 -16         0                                            0
+Frame2:  B    4   2        0.3536   0            0              0           2                3         -4 -6  4               1       4        5         1 1 0 0 1         0
+Frame3:  B    2   3        0.3536   0            0              0           2                4         -2 -4  2 6             1       2        4         1 1 1 1           0
+Frame4:  B    1   4        0.68     0            0              0           2                4         -1  1  3 7             1       1        5         1 0 1 1 1         0
+Frame5:  B    3   4        0.68     0            0              0           2                4         -1 -3  1 5             1      -2        5         1 1 1 1 0         0
+Frame6:  B    6   3        0.3536   0            0              0           2                4         -2 -4 -6 2             1      -3        5         1 1 1 1 0         0
+Frame7:  B    5   4        0.68     0            0              0           2                4         -1 -5  1 3             1       1        5         1 0 1 1 1         0
+Frame8:  B    7   4        0.68     0            0              0           2                4         -1 -3 -7 1             1      -2        5         1 1 1 1 0         0
 
-FrameEL1:  B    8   1        0.442    0            0              0           4                4         -8 -10 -12 -16         0
-FrameEL2:  B    4   2        0.3536   0            0              0           2                3         -4 -6  4               1       4        5         1 1 0 0 1
-FrameEL3:  B    2   3        0.3536   0            0              0           2                4         -2 -4  2 6             1       2        4         1 1 1 1
-FrameEL4:  B    1   4        0.68     0            0              0           2                4         -1  1  3 7             1       1        5         1 0 1 1 1
-FrameEL5:  B    3   4        0.68     0            0              0           2                4         -1 -3  1 5             1      -2        5         1 1 1 1 0
-FrameEL6:  B    6   3        0.3536   0            0              0           2                4         -2 -4 -6 2             0
-FrameEL7:  B    5   4        0.68     0            0              0           2                4         -1 -5  1 3             0
-FrameEL8:  B    7   4        0.68     0            0              0           2                4         -1 -3 -7 1             0
+FrameEL1:  B    8   1        0.442    0            0              0           4                4         -8 -10 -12 -16         0                                          0
+FrameEL2:  B    4   2        0.3536   0            0              0           2                3         -4 -6  4               1       4        5         1 1 0 0 1       0
+FrameEL3:  B    2   3        0.3536   0            0              0           2                4         -2 -4  2 6             1       2        4         1 1 1 1         0
+FrameEL4:  B    1   4        0.68     0            0              0           2                4         -1  1  3 7             1       1        5         1 0 1 1 1       0
+FrameEL5:  B    3   4        0.68     0            0              0           2                4         -1 -3  1 5             1      -2        5         1 1 1 1 0       0
+FrameEL6:  B    6   3        0.3536   0            0              0           2                4         -2 -4 -6 2             0                                          1    1 1 0 1
+FrameEL7:  B    5   4        0.68     0            0              0           2                4         -1 -5  1 3             0                                          0
+FrameEL8:  B    7   4        0.68     0            0              0           2                4         -1 -3 -7 1             0                                          1    1 1 0 1
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
Index: branches/SHM-3.0-dev/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- branches/SHM-3.0-dev/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 356)
+++ branches/SHM-3.0-dev/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 357)
@@ -217,4 +217,16 @@
     {
       in>>entry.m_refIdc[i];
+    }
+  }
+#endif
+#if EXTERNAL_USEDBYCURR_N0082
+  if(entry.m_numRefPics>0){
+    in>>entry.m_UseExtusedByCurrPic;
+    if(entry.m_UseExtusedByCurrPic)
+    {
+      for ( Int i = 0; i < entry.m_numRefPics; i++ )
+      {
+        in>>entry.m_ExtusedByCurrPic[i];
+      }
     }
   }
@@ -1467,9 +1479,9 @@
 #endif
   
-#if !FINAL_RPL_CHANGE_N0082
+#if EXTERNAL_USEDBYCURR_N0082|| !FINAL_RPL_CHANGE_N0082
   Bool verifiedGOP=false;
 #endif
   Bool errorGOP=false;
-#if !FINAL_RPL_CHANGE_N0082
+#if  EXTERNAL_USEDBYCURR_N0082|| !FINAL_RPL_CHANGE_N0082
   Int checkGOP=1;
   Int numRefs = 1;
@@ -1482,5 +1494,5 @@
     isOK[i]=false;
   }
-#if !FINAL_RPL_CHANGE_N0082
+#if  EXTERNAL_USEDBYCURR_N0082|| !FINAL_RPL_CHANGE_N0082
   Int numOK=0;
 #endif
@@ -1530,5 +1542,6 @@
   for(UInt layer=0; layer<m_numLayers; layer++)
   {
-    if (m_acLayerCfg[layer].m_GOPListLayer[0].m_POC<0){
+    if (m_acLayerCfg[layer].m_GOPListLayer[0].m_POC<0)
+    {
       memcpy( m_acLayerCfg[layer].m_GOPListLayer, m_GOPList, sizeof(GOPEntry)*MAX_GOP );
     }
@@ -1536,14 +1549,7 @@
     xConfirmPara(errorGOP,"Invalid GOP structure given");
   }
-  //tentative for encoder
-  if( m_acLayerCfg[1].m_GOPListLayer[5].m_POC == 6  && m_acLayerCfg[1].m_GOPListLayer[7].m_POC == 7 ){
-    //RA, POC5
-    m_acLayerCfg[1].m_GOPListLayer[5].m_usedByCurrPic[2] = 0;
-    m_acLayerCfg[1].m_GOPListLayer[5].m_refIdc[2] = 0;
-    //RA, POC7
-    m_acLayerCfg[1].m_GOPListLayer[7].m_usedByCurrPic[2] = 0;
-    m_acLayerCfg[1].m_GOPListLayer[7].m_refIdc[2] = 0;
-  }
+#if !EXTERNAL_USEDBYCURR_N0082
 #else
+#endif
   m_extraRPSs=0;
   //start looping through frames in coding order until we can verify that the GOP structure is correct.
@@ -1741,4 +1747,21 @@
   }
   xConfirmPara(errorGOP,"Invalid GOP structure given");
+#if !EXTERNAL_USEDBYCURR_N0082
+#endif
+#endif
+#if EXTERNAL_USEDBYCURR_N0082
+  for(UInt layer=0; layer<m_numLayers; layer++)
+  {
+    for (Int i=0; i< m_iGOPSize; i++){
+      if (m_acLayerCfg[layer].m_GOPListLayer[i].m_UseExtusedByCurrPic == 1 )
+      {
+        for(Int j=0; j<m_acLayerCfg[layer].m_GOPListLayer[i].m_numRefPics; j++ )
+        {
+          m_acLayerCfg[layer].m_GOPListLayer[i].m_usedByCurrPic[j] = m_acLayerCfg[layer].m_GOPListLayer[i].m_ExtusedByCurrPic[j];
+          m_acLayerCfg[layer].m_GOPListLayer[i].m_refIdc[j] = m_acLayerCfg[layer].m_GOPListLayer[i].m_ExtusedByCurrPic[j];
+        }
+      }
+    }
+  }
 #endif
   m_maxTempLayer = 1;
Index: branches/SHM-3.0-dev/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/SHM-3.0-dev/source/Lib/TLibCommon/TypeDef.h	(revision 356)
+++ branches/SHM-3.0-dev/source/Lib/TLibCommon/TypeDef.h	(revision 357)
@@ -49,4 +49,5 @@
 #define RPL_INIT_N0316_N0082             1      ///< N0316, N0082: initial reference picture list construction 
 #define FINAL_RPL_CHANGE_N0082           1      ///< N0082: final ref picture list change (encoder)
+#define EXTERNAL_USEDBYCURR_N0082        1      ///< N0082: final ref picture list change (encoder) //dev ver.
 #define M0464_TILE_BOUNDARY_ALIGNED_FLAG 1      ///< VUI flag to indicate tile boundary alignment
 #define M0463_VUI_EXT_ILP_REF            1      ///< VUI extension inter-layer dependency offset signalling
Index: branches/SHM-3.0-dev/source/Lib/TLibEncoder/TEncCfg.h
===================================================================
--- branches/SHM-3.0-dev/source/Lib/TLibEncoder/TEncCfg.h	(revision 356)
+++ branches/SHM-3.0-dev/source/Lib/TLibEncoder/TEncCfg.h	(revision 357)
@@ -69,4 +69,8 @@
   Int m_numRefIdc;
   Int m_refIdc[MAX_NUM_REF_PICS+1];
+#if EXTERNAL_USEDBYCURR_N0082
+  Int m_UseExtusedByCurrPic;
+  Int m_ExtusedByCurrPic[MAX_NUM_REF_PICS];
+#endif
   GOPEntry()
   : m_POC(-1)
@@ -83,8 +87,14 @@
   , m_deltaRPS(0)
   , m_numRefIdc(0)
+#if EXTERNAL_USEDBYCURR_N0082
+  , m_UseExtusedByCurrPic(0)
+#endif
   {
     ::memset( m_referencePics, 0, sizeof(m_referencePics) );
     ::memset( m_usedByCurrPic, 0, sizeof(m_usedByCurrPic) );
     ::memset( m_refIdc,        0, sizeof(m_refIdc) );
+#if EXTERNAL_USEDBYCURR_N0082
+    ::memset( m_usedByCurrPic, 0, sizeof(m_ExtusedByCurrPic) );
+#endif
   }
 };